
User Interface - Bug #2770

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

alert-box visual differences

10/20/2015 04:25 PM - Greg Shah

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Hynek Cihlar % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 10/20/2015 04:31 PM - Greg Shah

- File simpler_alert_box_in_p2j_swing_20151020.png added

- File simpler_alert_box_in_progress_20151020.png added

The P2J version of alert-box has 3 visual differences as compared to the Progress version.

Progress:

 

P2J (branch 1811s revision 11003):

 

Here are the problems:

1. The size of the P2J alert-box is too big.

2. The default button "No" doesn't have the focus (pressing space or enter should select the default button and close the alert-box, in P2J we must

use the mouse).

3. The window close button should be drawn as disabled.

The 3D border issue is also visible above, but it is being worked in #2763, not here.
https://proj.goldencode.com/issues/2763


#2 - 10/20/2015 04:32 PM - Greg Shah

I did run this with updated text metrics, so the sizing problem shouldn't be due to that.

#3 - 10/21/2015 05:58 PM - Hynek Cihlar

The differences resolved in 1811s revision 11011.

The checkin also adds proper handling of window caption close button.

Note that a regression broke all the keyboard input, this is being solved.

#4 - 10/22/2015 06:25 AM - Hynek Cihlar

1811s revision 11014 fixes an unhandled exception when alert-box closed through the window caption button.

#5 - 10/22/2015 09:22 AM - Greg Shah

- File simpler_alert_box_progress_vs_p2j_swing_button_width_is_same_20151022.png added

- File simpler_alert_box_progress_vs_p2j_swing_width_and_height_differs_20151022.png added

- File simpler_alert_box_progress_vs_p2j_swing_height_differs_20151022.png added

- File simpler_alert_box_progress_vs_p2j_swing_button_height_differs_20151022.png added

- File simpler_alert_box_in_p2j_swing_20151022.png added

OK, this is very close now.

P2J Swing:

 

There are still slight size differences.
(The top alert-box is Progress and bottom is P2J.)

1. Both width and height differ.  Part of the problem is that there is 1 extra pixel in the border of P2J.
(The left/below alert-box is Progress and above/right is P2J.)

2. The titlebar is 1 pixel too tall in P2J.

3. The icon is too big in P2J.

 

(The lower/below alert-box is Progress and above/top is P2J.)
(The left/below alert-box is Progress and above/right is P2J.)

4. The button widths are OK, but the positioning is off by a pixel.

5. The button heights are off by 1 pixel.

#6 - 03/23/2016 05:08 PM - Greg Shah

- Target version changed from Milestone 12 to Milestone 16
#7 - 04/22/2016 03:56 AM - Hynek Cihlar

- File alert-box_icons_compare.png added

Greg Shah wrote:

3. The icon is too big in P2J.

 

Greg, I just realized the icon sizes are equal. Your screenshot from native 4GL seems to be somehow deformed. I am attaching the screenshot

capturing the icons from my devsrv01 (left icon on the image) session and P2J.

 

#8 - 04/22/2016 07:37 AM - Greg Shah

When you say devsrv01, did you mean winsrv01?

#9 - 04/22/2016 07:40 AM - Hynek Cihlar

Greg Shah wrote:

When you say devsrv01, did you mean winsrv01?

 

Yes :-).

#10 - 04/22/2016 07:46 AM - Hynek Cihlar

Hynek Cihlar wrote:

Greg Shah wrote:

When you say devsrv01, did you mean winsrv01?

05/03/2024 6/14



 

Yes :-).

 

Actually I meant windev01. When you connect remotely do you maybe rescale the resolution?

#11 - 04/22/2016 08:01 AM - Greg Shah

Sorry, my mistake too, I also meant windev01. :)

I did not intentionally scale the resolution, but it may have happened anyway.  If the size is right, then we won't worry about that issue.

Did you look at the changes in #3048?  How do those affect this task?

#12 - 04/22/2016 08:29 AM - Hynek Cihlar

Greg Shah wrote:

Sorry, my mistake too, I also meant windev01. :)

I did not intentionally scale the resolution, but it may have happened anyway.  If the size is right, then we won't worry about that issue.

Did you look at the changes in #3048?  How do those affect this task?

 

I don't think the changes in #3048 affect this task.

#13 - 04/24/2016 03:29 PM - Hynek Cihlar

- File icons_antialiasing.png added

Eugenie, when I rasterize alert-box icon using SharpPNGTranscoder I get a very distorted output. But if I use the unmodified Batik PNGTranscoder

directly, I get the expected output. See below.
What do you advise?

#14 - 04/24/2016 05:11 PM - Eugenie Lyzenko

Hynek Cihlar wrote:

Eugenie, when I rasterize alert-box icon using SharpPNGTranscoder I get a very distorted output. But if I use the unmodified Batik

PNGTranscoder directly, I get the expected output. See below.

What do you advise?

 

The SharpPNGTranscoder just turns anti-alias off. It was introduced for drawing all solid icons like scrollbar buttons. And this is how the batik package

works with image.

What is the original image? What is your goal? You need to have the image without anti-alias?

If you need antialias to be off and want to have some predefined picture in P2J the approach is:

- take original picture

- make a change to original picture to adjust the final result.

There ane no shortcuts here. You will have to find out how the changes in original picture produces the final result. Pixel by pixel.

The better way if the image size is constant I guess is to use simple bitmap. And no BATIK or other third party image handling tools.
#15 - 04/26/2016 04:35 AM - Hynek Cihlar

2770a rebased against trunk 11012, the branch is now at rev 11014.

#16 - 04/26/2016 09:31 AM - Greg Shah

Can you provide an update on this work?

#17 - 04/27/2016 03:50 AM - Hynek Cihlar

Greg Shah wrote:

Can you provide an update on this work?

 

The core changes are in place. And the issues above addressed.

TODOs are, retest after rebase against trunk 11012 and minor code cleanup.

#18 - 04/27/2016 04:45 AM - Hynek Cihlar

2770a rebased against trunk 11015, the branch is now at rev 11017.

#19 - 04/27/2016 09:49 AM - Hynek Cihlar

Hynek Cihlar wrote:

Greg Shah wrote:

Can you provide an update on this work?

 

The core changes are in place. And the issues above addressed.

TODOs are, retest after rebase against trunk 11012 and minor code cleanup.

 

There is one more regression, the window can be resized only by its right/bottom edges, but not the top/left ones. I am working on this right now.

#20 - 04/28/2016 03:33 PM - Hynek Cihlar

2770a rebased against trunk 11016, the branch is now at rev 11024.
#21 - 04/28/2016 03:34 PM - Greg Shah

Is this ready for code review?

#22 - 04/28/2016 03:43 PM - Hynek Cihlar

Please review 2770a revision 11025.

The revision resolves the ALERT-BOX layout issues mentioned in the above notes. It also resolves Swing window resizing issues - resizing cursor

sometime not appearing, sometime disappearing unexpectedly, window resizing sometime moving the whole window. Plus other related fixes.

The revision passes GUI regression tests. Since the changes are only in GUI code, no ChUI regression testing is needed.

#23 - 04/28/2016 03:43 PM - Hynek Cihlar

Greg Shah wrote:

Is this ready for code review?

 

Revision 11025 is.

#24 - 04/28/2016 03:44 PM - Hynek Cihlar

Eugenie Lyzenko wrote:

The better way if the image size is constant I guess is to use simple bitmap. And no BATIK or other third party image handling tools.

 

Eugenie, please review 2770a revision 11025. It contains changes related to the subject above.

#25 - 04/28/2016 03:46 PM - Hynek Cihlar

2770a 11025 also resolves #3067.

#26 - 04/28/2016 04:32 PM - Greg Shah

Code Review Task Branch 2770a Revision 11025

I'm generally fine with the changes.

1. In WindowBorder, please put a line break before the implements.

2. How does the AbstractContainer change affect ChUI?
#27 - 04/28/2016 05:15 PM - Eugenie Lyzenko

Eugenie, please review 2770a revision 11025. It contains changes related to the subject above.

 

Three considerations:

1. Did you classify all cases when the aliasing must be on and when must be off? We need to avoid 4GL - P2J visual mismatch.

2. In AlertBoxGuiImpl the icon image coordinate has hardcoded coords dependent on PADDING character unit related coord. Why not to just center

the image withing rectangle? What if the font size is changing, will the image position be OK.

3. Your drawImage() does not use image transparency, is it intentional? Does the 4GL show the same behavior?

#28 - 04/29/2016 02:06 AM - Hynek Cihlar

Greg Shah wrote:

Code Review Task Branch 2770a Revision 11025

I'm generally fine with the changes.

1. In WindowBorder, please put a line break before the implements.

 

Resolved in 11026. I also added one more javadoc.

2. How does the AbstractContainer change affect ChUI?

 

The changed method is only executed in GUI context.

#29 - 04/29/2016 02:11 AM - Hynek Cihlar

Eugenie Lyzenko wrote:

Eugenie, please review 2770a revision 11025. It contains changes related to the subject above.
Three considerations:

1. Did you classify all cases when the aliasing must be on and when must be off? We need to avoid 4GL - P2J visual mismatch.

 

There is only one case ATM where antialiasing needs to be ON, and that is the ALERT-BOX icons.

2. In AlertBoxGuiImpl the icon image coordinate has hardcoded coords dependent on PADDING character unit related coord. Why not to just

center the image withing rectangle? What if the font size is changing, will the image position be OK.

 

The icon position depends on Windows message box font size theme settings.

3. Your drawImage() does not use image transparency, is it intentional? Does the 4GL show the same behavior?

 

Although the icons use transparency, I didn't have a need to turn that flag on. The source SVGs have transparent backgrounds (they don't contain

any drawings) and so Batik rasterizer creates the rastered images with correct transparency.

For which cases is the transparency flag needed anyway?

#30 - 04/29/2016 09:53 AM - Greg Shah

Please merge 2770a to trunk.

#31 - 04/29/2016 01:20 PM - Hynek Cihlar

2770a merged to trunk as revision 11017. The branch has been archived.

#32 - 04/29/2016 01:21 PM - Hynek Cihlar

- % Done changed from 0 to 100

- Status changed from New to WIP

#33 - 04/29/2016 01:25 PM - Greg Shah

- Status changed from WIP to Closed

#34 - 04/29/2016 02:59 PM - Hynek Cihlar

Please review task branch 2770b revision 11018, it fixes GUI regressions caused by assigning widget IDs to all BorderedPanelGuiImpl instances.
#35 - 04/29/2016 03:09 PM - Greg Shah

Code Review Task Branch 2770b Revision 11018

The changes are fine.

Please add the embedded mode fix to this branch (when you have it ready).

#36 - 04/29/2016 04:09 PM - Hynek Cihlar

2770b revision 11019 fixes main window border being drawn even when the driver doesn't support window decorations. Please review.

#37 - 04/30/2016 06:11 AM - Greg Shah

Code Review Task Branch 2770b Revision 11019

The changes are fine.

#38 - 05/02/2016 06:57 AM - Hynek Cihlar

2770a rebased against trunk 11019, the branch is now at rev 11022.

#39 - 05/02/2016 10:29 AM - Hynek Cihlar

2770b revision 11025 resolves regressions introduced by 2770a, fixes selection of next active window when modal window with no visible owner is

being hidden and attempts to fix Swing JFrame sometime not focusing when JFrame.requestFocus() called right after the window is made visible.

GUI regression tests passed, ChUI regression testing is not needed as the changes only affect GUI code.

Please review.

#40 - 05/02/2016 04:02 PM - Greg Shah

Code Review Task Branch 2770b Revision 11025

I'm fine with the changes.

Please merge to trunk.

#41 - 05/02/2016 04:29 PM - Hynek Cihlar

2770b merged to trunk as revision 11020. The branch was archived.

#42 - 11/16/2016 12:22 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI
